using System;
using System.Collections.Generic;
using System.Reflection;
using M17N;
using M17N.Core;

public class Test
{
  public static void Main()
  {
    MSymbol sym1 = MSymbol.Of ("symbol");
    MSymbol sym2 = MSymbol.Of ("symbol");
    MSymbol sym3 = MSymbol.Of ("another sym:bol");

    Console.WriteLine ("version {0}-{1}-{2}", M17n.MajorVersion,
		       M17n.MinorVersion, M17n.ReleaseNumber);

    Console.WriteLine ("sym1 = {0}", sym1);
    Console.WriteLine ("sym2 = {0}", sym2);
    Console.WriteLine ("sym3 = {0}", sym3);
    Console.WriteLine ("sym1 {0} sym2", sym1 == sym2 ? "==" : "!=");
    Console.WriteLine ("sym1 {0} sym3", sym1 == sym3 ? "==" : "!=");

    sym1.Put (sym2, "prop1");
    sym1.Put (sym3, "prop2");
    Console.WriteLine (sym1.Get (sym2) + "," + sym1.Get (sym3));
    Console.WriteLine (sym2.Get (sym2) + "," + sym2.Get (sym3));
    Console.WriteLine (sym3.Get (sym2));

    MSymbol sym4 = MSymbol.PropertyKey ("symbol");
    try {
      sym4 = MSymbol.PropertyKey ("symbol", MProperty.Flags.Sensitive);
    } catch {
      Console.WriteLine ("MProperty.Flags mismatch");
    }
    sym4 = MSymbol.PropertyKey ("symbol", MProperty.Flags.None);
    sym4 = MSymbol.PropertyKey ("symbol");
    Console.WriteLine (sym4);
  }
}
